### Home Classes Methods

### In Files

- lib/sass/util/test.rb
- lib/sass/util/subset_map.rb
- lib/sass/util.rb

### Namespace

- MODULE Sass::Util::Test
- CLASS Sass::Util::MultibyteStringScanner
- CLASS Sass::Util::StaticConditionalContext
- CLASS Sass::Util::SubsetMap

### Methods

- #_enc
- #abstract
- #ap_geq?
- #ap_geq_3?
- #array_minus
- #atomic_create_and_write_file
- #av_template_class
- #caller_info
- #check_encoding
- #check_range
- #check_sass_encoding
- #destructure
- #enum_cons
- #enum_slice
- #enum_with_index
- #extract!
- #extract_values
- #flatten
- #glob
- #group_by_to_a
- #has?
- #hash_to_a
- #inject_values
- #inspect_obj
- #intersperse
- #ironruby?
- #jruby1_6?
- #jruby?
- #jruby_version
- #lcs
- #macruby?
- #map_hash
- #map_keys
- #map_vals
- #merge_adjacent_strings
- #ord
- #paths
- #powerset
- #rails_env
- #rails_root
- #rbx?
- #restrict
- #ruby1?
- #ruby1_8?
- #ruby1_8_6?
- #sass_warn
- #scope
- #set_eql?
- #set_hash
- #silence_sass_warnings
- #silence_warnings
- #strip_string_array
- #subsequence?
- #substitute
- #to_hash
- #undefined_conversion_error_char
- #version_geq
- #version_gt
- #windows?
- #with_extracted_values

### Class/Module Index

Quicksearch

- Sass
- Sass::CSS
- Sass::CacheStores
- Sass::CacheStores::Base
- Sass::CacheStores::Chain
- Sass::CacheStores::Filesystem
- Sass::CacheStores::Memory
- Sass::CacheStores::Null
- Sass::Callbacks
- Sass::Callbacks::InstanceMethods
- Sass::Engine
- Sass::Engine::Line
- Sass::Environment
- Sass::Exec
- Sass::Exec::Generic
- Sass::Exec::Sass
- Sass::Exec::SassConvert
- Sass::Exec::Scss
- Sass::Importers
- Sass::Importers::Base
- Sass::Importers::Filesystem
- Sass::Logger
- Sass::Logger::Base
- Sass::Logger::LogLevel
- Sass::Logger::LogLevel::ClassMethods
- Sass::Media
- Sass::Media::Query
- Sass::Media::QueryList
- Sass::Plugin
- Sass::Plugin::Compiler
- Sass::Plugin::Configuration
- Sass::Plugin::MerbBootLoader
- Sass::Plugin::Rack
- Sass::Plugin::StalenessChecker
- Sass::Repl
- Sass::SCSS
- Sass::SCSS::CssParser
- Sass::SCSS::Parser
- Sass::SCSS::RX
- Sass::SCSS::ScriptLexer
- Sass::SCSS::ScriptParser
- Sass::SCSS::StaticParser
- Sass::Script
- Sass::Script::ArgList
- Sass::Script::Bool
- Sass::Script::Color
- Sass::Script::CssLexer
- Sass::Script::CssParser
- Sass::Script::Funcall
- Sass::Script::Functions
- Sass::Script::Functions::EvaluationContext
- Sass::Script::Interpolation
- Sass::Script::Lexer
- Sass::Script::List
- Sass::Script::Literal
- Sass::Script::Node
- Sass::Script::Null
- Sass::Script::Number
- Sass::Script::Operation
- Sass::Script::Parser
- Sass::Script::String
- Sass::Script::StringInterpolation
- Sass::Script::UnaryOperation
- Sass::Script::Variable
- Sass::Selector
- Sass::Selector::AbstractSequence
- Sass::Selector::Attribute
- Sass::Selector::Class
- Sass::Selector::CommaSequence
- Sass::Selector::Element
- Sass::Selector::Id
- Sass::Selector::Interpolation
- Sass::Selector::Parent
- Sass::Selector::Placeholder
- Sass::Selector::Pseudo
- Sass::Selector::SelectorPseudoClass
- Sass::Selector::Sequence
- Sass::Selector::Simple
- Sass::Selector::SimpleSequence
- Sass::Selector::Universal
- Sass::Shared
- Sass::Supports
- Sass::Supports::Condition
- Sass::Supports::Declaration
- Sass::Supports::Interpolation
- Sass::Supports::Negation
- Sass::Supports::Operator
- Sass::SyntaxError
- Sass::Tree
- Sass::Tree::CharsetNode
- Sass::Tree::CommentNode
- Sass::Tree::ContentNode
- Sass::Tree::CssImportNode
- Sass::Tree::DebugNode
- Sass::Tree::DirectiveNode
- Sass::Tree::EachNode
- Sass::Tree::ExtendNode
- Sass::Tree::ForNode
- Sass::Tree::FunctionNode
- Sass::Tree::IfNode
- Sass::Tree::ImportNode
- Sass::Tree::MediaNode
- Sass::Tree::MixinDefNode
- Sass::Tree::MixinNode
- Sass::Tree::Node
- Sass::Tree::PropNode
- Sass::Tree::ReturnNode
- Sass::Tree::RootNode
- Sass::Tree::RuleNode
- Sass::Tree::SupportsNode
- Sass::Tree::TraceNode
- Sass::Tree::VariableNode
- Sass::Tree::Visitors
- Sass::Tree::Visitors::Base
- Sass::Tree::Visitors::CheckNesting
- Sass::Tree::Visitors::Convert
- Sass::Tree::Visitors::Cssize
- Sass::Tree::Visitors::DeepCopy
- Sass::Tree::Visitors::Extend
- Sass::Tree::Visitors::Perform
- Sass::Tree::Visitors::SetOptions
- Sass::Tree::Visitors::ToCss
- Sass::Tree::WarnNode
- Sass::Tree::WhileNode
- Sass::UnitConversionError
- Sass::Util
- Sass::Util::MultibyteStringScanner
- Sass::Util::StaticConditionalContext
- Sass::Util::SubsetMap
- Sass::Util::Test
- Sass::Version
- ActionController
- ActionController::Base
- Object

No matching classes.

# Sass::Util

A module containing various useful functions.

### Constants

CHARSET_REGEXPS
ENCODINGS_TO_CHECK

  We could automatically add in any non-ASCII-compatible encodings here, but there's not really a good way to do that without manually checking that each encoding encodes all ASCII characters properly, which takes long enough to affect the startup time of the CLI.

RUBY_ENGINE

  The Ruby engine we're running under. Defaults to `"ruby"` if the top-level constant is undefined. @api public

RUBY_VERSION

  An array of ints representing the Ruby version number. @api public

### Public Instance Methods

_enc(string, encoding) click to toggle source

@private

    # File lib/sass/util.rb, line 660
    def _enc(string, encoding)
      string.encode(encoding).force_encoding("BINARY")
    end

abstract(obj) click to toggle source

Throws a NotImplementedError for an abstract method.

@param obj [Object] `self` @raise [NotImplementedError]

    # File lib/sass/util.rb, line 381
    def abstract(obj)
      raise NotImplementedError.new("#{obj.class} must implement ##{caller_info[2]}")
    end

ap_geq?(version) click to toggle source

Returns whether this environment is using ActionPack of a version greater than or equal to that specified.

@param version [String] The string version number to check against.

    Should be greater than or equal to Rails 3,
    because otherwise ActionPack::VERSION isn't autoloaded

@return [Boolean]

    # File lib/sass/util.rb, line 456
    def ap_geq?(version)
      # The ActionPack module is always loaded automatically in Rails >= 3
      return false unless defined?(ActionPack) && defined?(ActionPack::VERSION) &&
        defined?(ActionPack::VERSION::STRING)

      version_geq(ActionPack::VERSION::STRING, version)
    end

ap_geq_3?() click to toggle source

Returns whether this environment is using ActionPack version 3.0.0 or greater.

@return [Boolean]

    # File lib/sass/util.rb, line 445
    def ap_geq_3?
      ap_geq?("3.0.0.beta1")
    end

array_minus(minuend, subtrahend) click to toggle source

Returns a sub-array of `minuend` containing only elements that are also in `subtrahend`. Ensures that the return value has the same order as `minuend`, even on Rubinius where that's not guaranteed by {Array#-}.

@param minuend [Array] @param subtrahend [Array] @return [Array]

    # File lib/sass/util.rb, line 267
    def array_minus(minuend, subtrahend)
      return minuend - subtrahend unless rbx?
      set = Set.new(minuend) - subtrahend
      minuend.select {|e| set.include?(e)}
    end

atomic_create_and_write_file(filename) click to toggle source

This creates a temp file and yields it for writing. When the write is complete, the file is moved into the desired location. The atomicity of this operation is provided by the filesystem's rename operation.

@param filename [String] The file to write to. @yieldparam tmpfile [Tempfile] The temp file that can be written to. @return The value returned by the block.

    # File lib/sass/util.rb, line 880
    def atomic_create_and_write_file(filename)
      require 'tempfile'
      tmpfile = Tempfile.new(File.basename(filename), File.dirname(filename))
      tmp_path = tmpfile.path
      tmpfile.binmode if tmpfile.respond_to?(:binmode)
      result = yield tmpfile
      File.rename tmpfile.path, filename
      result
    ensure
      # close and remove the tempfile if it still exists,
      # presumably due to an error during write
      tmpfile.close if tmpfile
      tmpfile.unlink if tmpfile
    end

av_template_class(name) click to toggle source

Returns an ActionView::Template* class. In pre-3.0 versions of Rails, most of these classes were of the form `ActionView::TemplateFoo`, while afterwards they were of the form `ActionView;:Template::Foo`.

@param name [to_s] The name of the class to get.

    For example, `:Error` will return `ActionView::TemplateError`
    or `ActionView::Template::Error`.

    # File lib/sass/util.rb, line 472
    def av_template_class(name)
      return ActionView.const_get("Template#{name}") if ActionView.const_defined?("Template#{name}")
      return ActionView::Template.const_get(name.to_s)
    end

caller_info(entry = nil) click to toggle source

Returns information about the caller of the previous method.

@param entry [String] An entry in the `caller` list, or a similarly formatted string @return [[String, Fixnum, (String, nil)]] An array containing the filename, line, and method name of the caller.

    The method name may be nil

    # File lib/sass/util.rb, line 329
    def caller_info(entry = nil)
      # JRuby evaluates `caller` incorrectly when it's in an actual default argument.
      entry ||= caller[1]
      info = entry.scan(/^(.*?):(-?.*?)(?::.*`(.+)')?$/).first
      info[1] = info[1].to_i
      # This is added by Rubinius to designate a block, but we don't care about it.
      info[2].sub!(/ \{\}\Z/, '') if info[2]
      info
    end

check_encoding(str) click to toggle source

Checks that the encoding of a string is valid in Ruby 1.9 and cleans up potential encoding gotchas like the UTF-8 BOM. If it's not, yields an error string describing the invalid character and the line on which it occurrs.

@param str [String] The string of which to check the encoding @yield [msg] A block in which an encoding error can be raised.

    Only yields if there is an encoding error

@yieldparam msg [String] The error message to be raised @return [String] `str`, potentially with encoding gotchas like BOMs removed

    # File lib/sass/util.rb, line 586
        def check_encoding(str)
          if ruby1_8?
            return str.gsub(/\A\xEF\xBB\xBF/, '') # Get rid of the UTF-8 BOM
          elsif str.valid_encoding?
            # Get rid of the Unicode BOM if possible
            if str.encoding.name =~ /^UTF-(8|16|32)(BE|LE)?$/
              return str.gsub(Regexp.new("\\A\uFEFF".encode(str.encoding.name)), '')
            else
              return str
            end
          end

          encoding = str.encoding
          newlines = Regexp.new("\r\n|\r|\n".encode(encoding).force_encoding("binary"))
          str.force_encoding("binary").split(newlines).each_with_index do |line, i|
            begin
              line.encode(encoding)
            rescue Encoding::UndefinedConversionError => e
              yield <<MSG.rstrip, i + 1
    Invalid #{encoding.name} character #{undefined_conversion_error_char(e)}
    MSG
            end
          end
          return str
        end

check_range(name, range, value, unit='') click to toggle source

Asserts that `value` falls within `range` (inclusive), leaving room for slight floating-point errors.

@param name [String] The name of the value. Used in the error message. @param range [Range] The allowed range of values. @param value [Numeric, Sass::Script::Number] The value to check. @param unit [String] The unit of the value. Used in error reporting. @return [Numeric] `value` adjusted to fall within range, if it

    was outside by a floating-point margin.

    # File lib/sass/util.rb, line 296
    def check_range(name, range, value, unit='')
      grace = (-0.00001..0.00001)
      str = value.to_s
      value = value.value if value.is_a?(Sass::Script::Number)
      return value if range.include?(value)
      return range.first if grace.include?(value - range.first)
      return range.last if grace.include?(value - range.last)
      raise ArgumentError.new(
        "#{name} #{str} must be between #{range.first}#{unit} and #{range.last}#{unit}")
    end

check_sass_encoding(str, &block) click to toggle source

Like {#check_encoding}, but also checks for a `@charset` declaration at the beginning of the file and uses that encoding if it exists.

The Sass encoding rules are simple. If a `@charset` declaration exists, we assume that that's the original encoding of the document. Otherwise, we use whatever encoding Ruby has. Then we convert that to UTF-8 to process internally. The UTF-8 end result is what's returned by this method.

@param str [String] The string of which to check the encoding @yield [msg] A block in which an encoding error can be raised.

    Only yields if there is an encoding error

@yieldparam msg [String] The error message to be raised @return [(String, Encoding)] The original string encoded as UTF-8,

    and the source encoding of the string (or `nil` under Ruby 1.8)

@raise [Encoding::UndefinedConversionError] if the source encoding

    cannot be converted to UTF-8

@raise [ArgumentError] if the document uses an unknown encoding with `@charset`

    # File lib/sass/util.rb, line 631
    def check_sass_encoding(str, &block)
      return check_encoding(str, &block), nil if ruby1_8?
      # We allow any printable ASCII characters but double quotes in the charset decl
      bin = str.dup.force_encoding("BINARY")
      encoding = Sass::Util::ENCODINGS_TO_CHECK.find do |enc|
        re = Sass::Util::CHARSET_REGEXPS[enc]
        re && bin =~ re
      end
      charset, bom = $1, $2
      if charset
        charset = charset.force_encoding(encoding).encode("UTF-8")
        if endianness = encoding[/[BL]E$/]
          begin
            Encoding.find(charset + endianness)
            charset << endianness
          rescue ArgumentError # Encoding charset + endianness doesn't exist
          end
        end
        str.force_encoding(charset)
      elsif bom
        str.force_encoding(encoding)
      end

      str = check_encoding(str, &block)
      return str.encode("UTF-8"), str.encoding
    end

destructure(val) click to toggle source

Prepare a value for a destructuring assignment (e.g. `a, b = val`). This works around a performance bug when using ActiveSupport, and only needs to be called when `val` is likely to be `nil` reasonably often.

See [this bug report](redmine.ruby-lang.org/issues/4917).

@param val [Object] @return [Object]

    # File lib/sass/util.rb, line 531
    def destructure(val)
      val || []
    end

enum_cons(enum, n) click to toggle source

A version of `Enumerable#enum_cons` that works in Ruby 1.8 and 1.9.

@param enum [Enumerable] The enumerable to get the enumerator for @param n [Fixnum] The size of each cons @return [Enumerator] The consed enumerator

    # File lib/sass/util.rb, line 718
    def enum_cons(enum, n)
      ruby1_8? ? enum.enum_cons(n) : enum.each_cons(n)
    end

enum_slice(enum, n) click to toggle source

A version of `Enumerable#enum_slice` that works in Ruby 1.8 and 1.9.

@param enum [Enumerable] The enumerable to get the enumerator for @param n [Fixnum] The size of each slice @return [Enumerator] The consed enumerator

    # File lib/sass/util.rb, line 727
    def enum_slice(enum, n)
      ruby1_8? ? enum.enum_slice(n) : enum.each_slice(n)
    end

enum_with_index(enum) click to toggle source

A version of `Enumerable#enum_with_index` that works in Ruby 1.8 and 1.9.

@param enum [Enumerable] The enumerable to get the enumerator for @return [Enumerator] The with-index enumerator

    # File lib/sass/util.rb, line 709
    def enum_with_index(enum)
      ruby1_8? ? enum.enum_with_index : enum.each_with_index
    end

extract!(array) click to toggle source

Destructively removes all elements from an array that match a block, and returns the removed elements.

@param array [Array] The array from which to remove elements. @yield [el] Called for each element. @yieldparam el [*] The element to test. @yieldreturn [Boolean] Whether or not to extract the element. @return [Array] The extracted elements.

    # File lib/sass/util.rb, line 739
    def extract!(array)
      out = []
      array.reject! do |e|
        next false unless yield e
        out << e
        true
      end
      out
    end

extract_values(arr) click to toggle source

Extracts the non-string vlaues from an array containing both strings and non-strings. These values are replaced with escape sequences. This can be undone using {#inject_values}.

This is useful e.g. when we want to do string manipulation on an interpolated string.

The precise format of the resulting string is not guaranteed. However, it is guaranteed that newlines and whitespace won't be affected.

@param arr [Array] The array from which values are extracted. @return [(String, Array)] The resulting string, and an array of extracted values.

    # File lib/sass/util.rb, line 814
    def extract_values(arr)
      values = []
      return arr.map do |e|
        next e.gsub('{', '{{') if e.is_a?(String)
        values << e
        next "{#{values.count - 1}}"
      end.join, values
    end

flatten(arr, n) click to toggle source

Flattens the first `n` nested arrays in a cross-version manner.

@param arr [Array] The array to flatten @param n [Fixnum] The number of levels to flatten @return [Array] The flattened array

    # File lib/sass/util.rb, line 762
    def flatten(arr, n)
      return arr.flatten(n) unless ruby1_8_6?
      return arr if n == 0
      arr.inject([]) {|res, e| e.is_a?(Array) ? res.concat(flatten(e, n - 1)) : res << e}
    end

glob(path, &block) click to toggle source

Like `Dir.glob`, but works with backslash-separated paths on Windows.

@param path [String]

    # File lib/sass/util.rb, line 517
    def glob(path, &block)
      path = path.gsub('\', '/') if windows?
      Dir.glob(path, &block)
    end

group_by_to_a(enum, &block) click to toggle source

Performs the equivalent of `enum.group_by.to_a`, but with a guaranteed order. Unlike [hash_to_a], the resulting order isn't sorted key order; instead, it's the same order as `group_by` has under Ruby 1.9 (key appearance order).

@param enum [Enumerable] @return [Array<[Object, Array]>] An array of pairs.

    # File lib/sass/util.rb, line 244
    def group_by_to_a(enum, &block)
      return enum.group_by(&block).to_a unless ruby1_8?
      order = {}
      arr = []
      enum.group_by do |e|
        res = block[e]
        unless order.include?(res)
          order[res] = order.size
        end
        res
      end.each do |key, vals|
        arr[order[key]] = [key, vals]
      end
      arr
    end

has?(attr, klass, method) click to toggle source

Checks to see if a class has a given method. For example:

    Sass::Util.has?(:public_instance_method, String, :gsub) #=> true

Method collections like `Class#instance_methods` return strings in Ruby 1.8 and symbols in Ruby 1.9 and on, so this handles checking for them in a compatible way.

@param attr [to_s] The (singular) name of the method-collection method

    (e.g. `:instance_methods`, `:private_methods`)

@param klass [Module] The class to check the methods of which to check @param method [String, Symbol] The name of the method do check for @return [Boolean] Whether or not the given collection has the given method

    # File lib/sass/util.rb, line 701
    def has?(attr, klass, method)
      klass.send("#{attr}s").include?(ruby1_8? ? method.to_s : method.to_sym)
    end

hash_to_a(hash) click to toggle source

Converts a Hash to an Array. This is usually identical to `Hash#to_a`, with the following exceptions:

- In Ruby 1.8, `Hash#to_a` is not deterministically ordered, but this is.

- In Ruby 1.9 when running tests, this is ordered in the same way it would be under Ruby 1.8 (sorted key order rather than insertion order).

@param hash [Hash] @return [Array]

    # File lib/sass/util.rb, line 232
    def hash_to_a(hash)
      return hash.to_a unless ruby1_8? || defined?(Test::Unit)
      return hash.sort_by {|k, v| k}
    end

inject_values(str, values) click to toggle source

Undoes {#extract_values} by transforming a string with escape sequences into an array of strings and non-string values.

@param str [String] The string with escape sequences. @param values [Array] The array of values to inject. @return [Array] The array of strings and values.

    # File lib/sass/util.rb, line 829
    def inject_values(str, values)
      return [str.gsub('{{', '{')] if values.empty?
      # Add an extra { so that we process the tail end of the string
      result = (str + '{{').scan(/(.*?)(?:(\{\{)|\{(\d+)\})/).map do |(pre, esc, n)|
        [pre, esc ? '{' : '', n ? values[n.to_i] : '']
      end.flatten(1)
      result[-2] = '' # Get rid of the extra {
      merge_adjacent_strings(result).reject {|s| s == ''}
    end

inspect_obj(obj) click to toggle source

Like `Object#inspect`, but preserves non-ASCII characters rather than escaping them under Ruby 1.9.2. This is necessary so that the precompiled Haml template can be `encode`d into `@options` before being evaluated.

@param obj {Object} @return {String}

    # File lib/sass/util.rb, line 795
    def inspect_obj(obj)
      return obj.inspect unless version_geq(::RUBY_VERSION, "1.9.2")
      return ':' + inspect_obj(obj.to_s) if obj.is_a?(Symbol)
      return obj.inspect unless obj.is_a?(String)
      '"' + obj.gsub(/[\x00-\x7F]+/) {|s| s.inspect[1...-1]} + '"'
    end

intersperse(enum, val) click to toggle source

Intersperses a value in an enumerable, as would be done with `Array#join` but without concatenating the array together afterwards.

@param enum [Enumerable] @param val @return [Array]

    # File lib/sass/util.rb, line 155
    def intersperse(enum, val)
      enum.inject([]) {|a, e| a << e << val}[0...-1]
    end

ironruby?() click to toggle source

Whether or not this is running on IronRuby.

@return [Boolean]

    # File lib/sass/util.rb, line 489
    def ironruby?
      RUBY_ENGINE == "ironruby"
    end

jruby1_6?() click to toggle source

Wehter or not this is running under JRuby 1.6 or lower.

    # File lib/sass/util.rb, line 565
    def jruby1_6?
      jruby? && jruby_version[0] == 1 && jruby_version[1] < 7
    end

jruby?() click to toggle source

Whether or not this is running on JRuby.

@return [Boolean]

    # File lib/sass/util.rb, line 503
    def jruby?
      RUBY_PLATFORM =~ /java/
    end

jruby_version() click to toggle source

Returns an array of ints representing the JRuby version number.

@return [Array<Fixnum>]

    # File lib/sass/util.rb, line 510
    def jruby_version
      $jruby_version ||= ::JRUBY_VERSION.split(".").map {|s| s.to_i}
    end

lcs(x, y, &block) click to toggle source

Computes a single longest common subsequence for `x` and `y`. If there are more than one longest common subsequences, the one returned is that which starts first in `x`.

@param x [Array] @param y [Array] @yield [a, b] An optional block to use in place of a check for equality

    between elements of `x` and `y`.

@yieldreturn [Object, nil] If the two values register as equal,

    this will return the value to use in the LCS array.

@return [Array] The LCS

    # File lib/sass/util.rb, line 216
    def lcs(x, y, &block)
      x = [nil, *x]
      y = [nil, *y]
      block ||= proc {|a, b| a == b && a}
      lcs_backtrace(lcs_table(x, y, &block), x, y, x.size-1, y.size-1, &block)
    end

macruby?() click to toggle source

Whether or not this is running under MacRuby.

@return [Boolean]

    # File lib/sass/util.rb, line 572
    def macruby?
      RUBY_ENGINE == 'macruby'
    end

map_hash(hash) click to toggle source

Maps the key-value pairs of a hash according to a block.

@example

    map_hash({:foo => "bar", :baz => "bang"}) {|k, v| [k.to_s, v.to_sym]}
      #=> {"foo" => :bar, "baz" => :bang}

@param hash [Hash] The hash to map @yield [key, value] A block in which the key-value pairs are transformed @yieldparam [key] The hash key @yieldparam [value] The hash value @yieldreturn [(Object, Object)] The new value for the `[key, value]` pair @return [Hash] The mapped hash @see map_keys @see map_vals

    # File lib/sass/util.rb, line 89
    def map_hash(hash)
      # Using &block here completely hoses performance on 1.8.
      to_hash(hash.map {|k, v| yield k, v})
    end

map_keys(hash) click to toggle source

Maps the keys in a hash according to a block.

@example

    map_keys({:foo => "bar", :baz => "bang"}) {|k| k.to_s}
      #=> {"foo" => "bar", "baz" => "bang"}

@param hash [Hash] The hash to map @yield [key] A block in which the keys are transformed @yieldparam key [Object] The key that should be mapped @yieldreturn [Object] The new value for the key @return [Hash] The mapped hash @see map_vals @see map_hash

    # File lib/sass/util.rb, line 56
    def map_keys(hash)
      to_hash(hash.map {|k, v| [yield(k), v]})
    end

map_vals(hash) click to toggle source

Maps the values in a hash according to a block.

@example

    map_values({:foo => "bar", :baz => "bang"}) {|v| v.to_sym}
      #=> {:foo => :bar, :baz => :bang}

@param hash [Hash] The hash to map @yield [value] A block in which the values are transformed @yieldparam value [Object] The value that should be mapped @yieldreturn [Object] The new value for the value @return [Hash] The mapped hash @see map_keys @see map_hash

    # File lib/sass/util.rb, line 72
    def map_vals(hash)
      to_hash(hash.map {|k, v| [k, yield(v)]})
    end

merge_adjacent_strings(arr) click to toggle source

Concatenates all strings that are adjacent in an array, while leaving other elements as they are.

@example

    merge_adjacent_strings([1, "foo", "bar", 2, "baz"])
      #=> [1, "foobar", 2, "baz"]

@param arr [Array] @return [Array] The enumerable with strings merged

    # File lib/sass/util.rb, line 132
    def merge_adjacent_strings(arr)
      # Optimize for the common case of one element
      return arr if arr.size < 2
      arr.inject([]) do |a, e|
        if e.is_a?(String)
          if a.last.is_a?(String)
            a.last << e
          else
            a << e.dup
          end
        else
          a << e
        end
        a
      end
    end

ord(c) click to toggle source

Returns the ASCII code of the given character.

@param c [String] All characters but the first are ignored. @return [Fixnum] The ASCII code of `c`.

    # File lib/sass/util.rb, line 753
    def ord(c)
      ruby1_8? ? c[0] : c.ord
    end

paths(arrs) click to toggle source

Return an array of all possible paths through the given arrays.

@param arrs [Array<Array>] @return [Array<Arrays>]

@example

    paths([[1, 2], [3, 4], [5]]) #=>
      # [[1, 3, 5],
      #  [2, 3, 5],
      #  [1, 4, 5],
      #  [2, 4, 5]]

    # File lib/sass/util.rb, line 199
    def paths(arrs)
      arrs.inject([[]]) do |paths, arr|
        flatten(arr.map {|e| paths.map {|path| path + [e]}}, 1)
      end
    end

powerset(arr) click to toggle source

Computes the powerset of the given array. This is the set of all subsets of the array.

@example

    powerset([1, 2, 3]) #=>
      Set[Set[], Set[1], Set[2], Set[3], Set[1, 2], Set[2, 3], Set[1, 3], Set[1, 2, 3]]

@param arr [Enumerable] @return [Set<Set>] The subsets of `arr`

    # File lib/sass/util.rb, line 102
    def powerset(arr)
      arr.inject([Set.new].to_set) do |powerset, el|
        new_powerset = Set.new
        powerset.each do |subset|
          new_powerset << subset
          new_powerset << subset + [el]
        end
        new_powerset
      end
    end

rails_env() click to toggle source

Returns the environment of the Rails application, if this is running in a Rails context. Returns `nil` if no such environment is defined.

@return [String, nil]

    # File lib/sass/util.rb, line 435
    def rails_env
      return ::Rails.env.to_s if defined?(::Rails.env)
      return RAILS_ENV.to_s if defined?(RAILS_ENV)
      return nil
    end

rails_root() click to toggle source

Returns the root of the Rails application, if this is running in a Rails context. Returns `nil` if no such root is defined.

@return [String, nil]

    # File lib/sass/util.rb, line 421
    def rails_root
      if defined?(::Rails.root)
        return ::Rails.root.to_s if ::Rails.root
        raise "ERROR: Rails.root is nil!"
      end
      return RAILS_ROOT.to_s if defined?(RAILS_ROOT)
      return nil
    end

rbx?() click to toggle source

Whether or not this is running on Rubinius.

@return [Boolean]

    # File lib/sass/util.rb, line 496
    def rbx?
      RUBY_ENGINE == "rbx"
    end

restrict(value, range) click to toggle source

Restricts a number to falling within a given range. Returns the number if it falls within the range, or the closest value in the range if it doesn't.

@param value [Numeric] @param range [Range<Numeric>] @return [Numeric]

    # File lib/sass/util.rb, line 120
    def restrict(value, range)
      [[value, range.first].max, range.last].min
    end

ruby1?() click to toggle source

Whether or not this is running under a Ruby version under 2.0.

@return [Boolean]

    # File lib/sass/util.rb, line 540
    def ruby1?
      Sass::Util::RUBY_VERSION[0] <= 1
    end

ruby1_8?() click to toggle source

Whether or not this is running under Ruby 1.8 or lower.

Note that IronRuby counts as Ruby 1.8, because it doesn't support the Ruby 1.9 encoding API.

@return [Boolean]

    # File lib/sass/util.rb, line 550
    def ruby1_8?
      # IronRuby says its version is 1.9, but doesn't support any of the encoding APIs.
      # We have to fall back to 1.8 behavior.
      ironruby? || (Sass::Util::RUBY_VERSION[0] == 1 && Sass::Util::RUBY_VERSION[1] < 9)
    end

ruby1_8_6?() click to toggle source

Whether or not this is running under Ruby 1.8.6 or lower. Note that lower versions are not officially supported.

@return [Boolean]

    # File lib/sass/util.rb, line 560
    def ruby1_8_6?
      ruby1_8? && Sass::Util::RUBY_VERSION[2] < 7
    end

sass_warn(msg) click to toggle source

The same as `Kernel#warn`, but is silenced by {#silence_sass_warnings}.

@param msg [String]

    # File lib/sass/util.rb, line 409
    def sass_warn(msg)
      msg = msg + "\n" unless ruby1?
      Sass.logger.warn(msg)
    end

scope(file) click to toggle source

Returns the path of a file relative to the Sass root directory.

@param file [String] The filename relative to the Sass root @return [String] The filename relative to the the working directory

    # File lib/sass/util.rb, line 29
    def scope(file)
      File.join(Sass::ROOT_DIR, file)
    end

set_eql?(set1, set2) click to toggle source

Tests the hash-equality of two sets in a cross-version manner. Aggravatingly, this is order-dependent in Ruby 1.8.6.

@param set1 [Set] @param set2 [Set] @return [Boolean] Whether or not the sets are hashcode equal

    # File lib/sass/util.rb, line 784
    def set_eql?(set1, set2)
      return set1.eql?(set2) unless ruby1_8_6?
      set1.to_a.uniq.sort_by {|e| e.hash}.eql?(set2.to_a.uniq.sort_by {|e| e.hash})
    end

set_hash(set) click to toggle source

Returns the hash code for a set in a cross-version manner. Aggravatingly, this is order-dependent in Ruby 1.8.6.

@param set [Set] @return [Fixnum] The order-independent hashcode of `set`

    # File lib/sass/util.rb, line 773
    def set_hash(set)
      return set.hash unless ruby1_8_6?
      set.map {|e| e.hash}.uniq.sort.hash
    end

silence_sass_warnings() click to toggle source

Silences all Sass warnings within a block.

@yield A block in which no Sass warnings will be printed

    # File lib/sass/util.rb, line 399
    def silence_sass_warnings
      old_level, Sass.logger.log_level = Sass.logger.log_level, :error
      yield
    ensure
      Sass.logger.log_level = old_level
    end

silence_warnings() click to toggle source

Silence all output to STDERR within a block.

@yield A block in which no output will be printed to STDERR

    # File lib/sass/util.rb, line 388
    def silence_warnings
      the_real_stderr, $stderr = $stderr, StringIO.new
      yield
    ensure
      $stderr = the_real_stderr
    end

strip_string_array(arr) click to toggle source

Destructively strips whitespace from the beginning and end of the first and last elements, respectively, in the array (if those elements are strings).

@param arr [Array] @return [Array] `arr`

    # File lib/sass/util.rb, line 182
    def strip_string_array(arr)
      arr.first.lstrip! if arr.first.is_a?(String)
      arr.last.rstrip! if arr.last.is_a?(String)
      arr
    end

subsequence?(seq1, seq2) click to toggle source

Returns whether or not `seq1` is a subsequence of `seq2`. That is, whether or not `seq2` contains every element in `seq1` in the same order (and possibly more elements besides).

@param seq1 [Array] @param seq2 [Array] @return [Boolean]

    # File lib/sass/util.rb, line 314
    def subsequence?(seq1, seq2)
      i = j = 0
      loop do
        return true if i == seq1.size
        return false if j == seq2.size
        i += 1 if seq1[i] == seq2[j]
        j += 1
      end
    end

substitute(ary, from, to) click to toggle source

Substitutes a sub-array of one array with another sub-array.

@param ary [Array] The array in which to make the substitution @param from [Array] The sequence of elements to replace with `to` @param to [Array] The sequence of elements to replace `from` with

    # File lib/sass/util.rb, line 164
    def substitute(ary, from, to)
      res = ary.dup
      i = 0
      while i < res.size
        if res[i...i+from.size] == from
          res[i...i+from.size] = to
        end
        i += 1
      end
      res
    end

to_hash(arr) click to toggle source

Converts an array of `[key, value]` pairs to a hash.

@example

    to_hash([[:foo, "bar"], [:baz, "bang"]])
      #=> {:foo => "bar", :baz => "bang"}

@param arr [Array<(Object, Object)>] An array of pairs @return [Hash] A hash

    # File lib/sass/util.rb, line 40
    def to_hash(arr)
      Hash[arr.compact]
    end

undefined_conversion_error_char(e) click to toggle source

Returns a string description of the character that caused an `Encoding::UndefinedConversionError`.

@param [Encoding::UndefinedConversionError] @return [String]

    # File lib/sass/util.rb, line 278
    def undefined_conversion_error_char(e)
      # Rubinius (as of 2.0.0.rc1) pre-quotes the error character.
      return e.error_char if rbx?
      # JRuby (as of 1.7.2) doesn't have an error_char field on
      # Encoding::UndefinedConversionError.
      return e.error_char.dump unless jruby?
      e.message[/^"[^"]+"/] #"
    end

version_geq(v1, v2) click to toggle source

Returns whether one version string represents the same or a more recent version than another.

@param v1 [String] A version string. @param v2 [String] Another version string. @return [Boolean]

    # File lib/sass/util.rb, line 373
    def version_geq(v1, v2)
      version_gt(v1, v2) || !version_gt(v2, v1)
    end

version_gt(v1, v2) click to toggle source

Returns whether one version string represents a more recent version than another.

@param v1 [String] A version string. @param v2 [String] Another version string. @return [Boolean]

    # File lib/sass/util.rb, line 344
    def version_gt(v1, v2)
      # Construct an array to make sure the shorter version is padded with nil
      Array.new([v1.length, v2.length].max).zip(v1.split("."), v2.split(".")) do |_, p1, p2|
        p1 ||= "0"
        p2 ||= "0"
        release1 = p1 =~ /^[0-9]+$/
        release2 = p2 =~ /^[0-9]+$/
        if release1 && release2
          # Integer comparison if both are full releases
          p1, p2 = p1.to_i, p2.to_i
          next if p1 == p2
          return p1 > p2
        elsif !release1 && !release2
          # String comparison if both are prereleases
          next if p1 == p2
          return p1 > p2
        else
          # If only one is a release, that one is newer
          return release1
        end
      end
    end

windows?() click to toggle source

Whether or not this is running on Windows.

@return [Boolean]

    # File lib/sass/util.rb, line 482
    def windows?
      RbConfig::CONFIG['host_os'] =~ /mswin|windows|mingw/
    end

with_extracted_values(arr) click to toggle source

Allows modifications to be performed on the string form of an array containing both strings and non-strings.

@param arr [Array] The array from which values are extracted. @yield [str] A block in which string manipulation can be done to the array. @yieldparam str [String] The string form of `arr`. @yieldreturn [String] The modified string. @return [Array] The modified, interpolated array.

    # File lib/sass/util.rb, line 847
    def with_extracted_values(arr)
      str, vals = extract_values(arr)
      str = yield str
      inject_values(str, vals)
    end

[Validate]

Generated with the Darkfish Rdoc Generator 2.